use DB_File;

if(!(defined($ARGV[0]))) {
    print stderr "Usage: hash.pl job_number\n";
    die;
}

$job = $ARGV[0];
print "Analyzing job number $job\n";
open(READ, "analyze.out") or (print "No analyze file for this job.\n" and die);

tie(%db, 'DB_File', "$ENV{SERVER_VAR}/databases/amplmods.db", O_RDWR|O_CREAT, 0644, $DB_HASH);

while(<READ>) {
    if(/:\s*(\S+)\s*=\s*(\S+)/) {
	$key = "$1_$job";
	$db{"$key"} = $2;
    }
}
close READ;

#while($key = each %db) { print "$key = $db{$key}\n";}

untie %db;
